| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Friends | List of all members
Strat::RefTree Class Reference
Strat

Tree of UnitRef's
More...

`#include <stratreftree.h>`

Inheritance diagram for Strat::RefTree:
[legend]

## Public Member Functions
| RefTree ()
| ~RefTree ()
bool | addLeavedUnit (const char *, const char *)
void | addLevelUnit (const Level &)
ContentSet & | contents ()
const ContentSet & | contents () const
void | createFromLevelSet (const LevelSet &)
| keep contents and lithologies
Strat::LeavedUnitRef * | getByLevel (LevelID) const
const LeavedUnitRef * | getLevelSetUnit (const char *lvlnm) const
int | level () const override
LithologySet & | lithologies ()
const LithologySet & | lithologies () const
bool | read (od_istream &)
void | removeLevelUnit (const Level &)
Repos::Source | source () const
const LeafUnitRef & | undefLeaf () const
bool | write (od_ostream &) const
Public Member Functions inherited from Strat::NodeOnlyUnitRef
| NodeOnlyUnitRef (NodeUnitRef *up, const char *c, const char *d=nullptr)
| ~NodeOnlyUnitRef ()
void | ensureTimeSorted ()
const LeafUnitRef * | firstLeaf () const override
bool | hasLeaves () const override
Type | type () const override
Public Member Functions inherited from Strat::NodeUnitRef
| NodeUnitRef (NodeUnitRef *, const char *, const char *d=nullptr)
| ~NodeUnitRef ()
virtual bool | add (UnitRef *, bool rev=false)
const OD::String & | code () const override
UnitRef * | find (const char *urcode)
const UnitRef * | find (const char *urcode) const
void | getPropsFrom (const IOPar &) override
bool | hasChildren () const override
void | incTimeRange (const Interval< float > &)
int | indexOf (const UnitRef *ur) const
virtual bool | insert (UnitRef *, int posidx)
bool | isEmpty () const override
bool | isParentOf (const UnitRef &) const override
virtual int | nrLeaves () const
int | nrRefs () const
void | putPropsTo (IOPar &) const override
UnitRef & | ref (int idx)
const UnitRef & | ref (int idx) const
void | remove (const UnitRef *ur)
void | remove (int uridx)
virtual UnitRef * | replace (int uridx, UnitRef *)
void | setCode (const char *c) override
void | setEmpty ()
virtual void | setTimeRange (const Interval< float > &)
void | swapChildren (int, int)
virtual Interval< float > | timeRange () const
Public Member Functions inherited from Strat::UnitRef
| UnitRef (NodeUnitRef *, const char *d=nullptr)
virtual | ~UnitRef ()
OD::Color | color () const
const OD::String & | description () const
virtual void | fill (BufferString &bs) const
CompoundKey | fullCode () const
bool | isBelow (const UnitRef *) const
| is given ref parent, grandparent, grandgrand...
bool | isLeaf () const
bool | isLeaved () const
virtual bool | isUndef () const
CompoundKey | parentCode () const
IOPar & | pars ()
const IOPar & | pars () const
bool | precedes (const UnitRef &) const
| in terms of iterating through tree
RefTree & | refTree ()
const RefTree & | refTree () const
void | setColor (OD::Color)
virtual void | setDescription (const char *d)
void | setUpNode (NodeUnitRef *newpar)
NodeUnitRef * | topNode ()
const NodeUnitRef * | topNode () const
int | treeDepth () const
NodeUnitRef * | upNode (int skip=0)
const NodeUnitRef * | upNode (int skip=0) const
virtual void | use (const char *s)
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Static Public Member Functions
static RefTree * | createStd (const char *)
static void | getStdNames (BufferStringSet &)
static const char * | sKeyNoCode ()
Static Public Member Functions inherited from Strat::UnitRef
static const char * | sKeyPropsFor ()
static const char * | sKeyTreeProps ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Public Attributes
BufferString | name_
Notifier< RefTree > | objectToBeDeleted
Repos::Source | src_
Notifier< UnitRef > | unitAdded
Notifier< UnitRef > | unitChanged
Notifier< UnitRef > | unitToBeDeleted
Public Attributes inherited from Strat::UnitRef
Notifier< UnitRef > | changed
Notifier< UnitRef > | toBeDeleted

## Protected Member Functions
void | initTree ()
void | levelSetChgCB (CallBacker *)
void | reportAdd (UnitRef &)
void | reportChange (UnitRef &, bool isrem=false)
void | setToActualTypes ()
Protected Member Functions inherited from Strat::NodeUnitRef
void | changeTimeRange (float dtime)
UnitRef * | fnd (const char *) const
void | takeChildrenFrom (NodeUnitRef *)
Protected Member Functions inherited from Strat::UnitRef
void | doFill (BufferString &, int) const
void | doUse (const char *, int *)
void | notifChange (bool isrem=false)

## Protected Attributes
bool | beingdeleted_ = false
ContentSet | contents_
LithologySet | liths_
LeafUnitRef & | udfleaf_
Protected Attributes inherited from Strat::NodeUnitRef
BufferString | code_
ObjectSet< UnitRef > | refs_
Interval< float > | timerg_
Protected Attributes inherited from Strat::UnitRef
OD::Color | color_
BufferString | desc_
IOPar | pars_
NodeUnitRef * | upnode_

## Friends
class | NodeUnitRef
class | RefTreeMgr
class | UnitRef

## Additional Inherited Members
Public Types inherited from Strat::UnitRef
enum | Type { NodeOnly , Leaved , Leaf }

## Detailed Description

Tree of UnitRef's

<>

## Constructor & Destructor Documentation

## ◆ RefTree()

Strat::RefTree::RefTree | ( |  | ) |

## ◆ ~RefTree()

Strat::RefTree::~RefTree | ( |  | ) |

## Member Function Documentation

## ◆ addLeavedUnit()

bool Strat::RefTree::addLeavedUnit | ( | const char * | ,
|  | const char * | )

## ◆ addLevelUnit()

void Strat::RefTree::addLevelUnit | ( | const Level & |  | ) |

## ◆ contents() [1/2]

ContentSet & Strat::RefTree::contents | ( |  | ) |
| inline

## ◆ contents() [2/2]

const ContentSet & Strat::RefTree::contents | ( |  | ) | const
| inline

## ◆ createFromLevelSet()

void Strat::RefTree::createFromLevelSet | ( | const LevelSet & |  | ) |

keep contents and lithologies

## ◆ createStd()

static RefTree * Strat::RefTree::createStd | ( | const char * |  | ) |
| static

## ◆ getByLevel()

Strat::LeavedUnitRef * Strat::RefTree::getByLevel | ( | LevelID |  | ) | const

## ◆ getLevelSetUnit()

const LeavedUnitRef * Strat::RefTree::getLevelSetUnit | ( | const char * | lvlnm | ) | const

## ◆ getStdNames()

static void Strat::RefTree::getStdNames | ( | BufferStringSet & |  | ) |
| static

## ◆ initTree()

void Strat::RefTree::initTree | ( |  | ) |
| protected

## ◆ level()

int Strat::RefTree::level | ( |  | ) | const
| inline override virtual

Reimplemented from Strat::NodeUnitRef.

## ◆ levelSetChgCB()

void Strat::RefTree::levelSetChgCB | ( | CallBacker * |  | ) |
| protected

## ◆ lithologies() [1/2]

LithologySet & Strat::RefTree::lithologies | ( |  | ) |
| inline

## ◆ lithologies() [2/2]

const LithologySet & Strat::RefTree::lithologies | ( |  | ) | const
| inline

## ◆ read()

bool Strat::RefTree::read | ( | od_istream & |  | ) |

## ◆ removeLevelUnit()

void Strat::RefTree::removeLevelUnit | ( | const Level & |  | ) |

## ◆ reportAdd()

void Strat::RefTree::reportAdd | ( | UnitRef & |  | ) |
| protected

## ◆ reportChange()

void Strat::RefTree::reportChange | ( | UnitRef & | ,
|  | bool | isrem = false )
| protected

## ◆ setToActualTypes()

void Strat::RefTree::setToActualTypes | ( |  | ) |
| protected

## ◆ sKeyNoCode()

static const char * Strat::RefTree::sKeyNoCode | ( |  | ) |
| inline static

## ◆ source()

Repos::Source Strat::RefTree::source | ( |  | ) | const
| inline

## ◆ undefLeaf()

const LeafUnitRef & Strat::RefTree::undefLeaf | ( |  | ) | const
| inline

## ◆ write()

bool Strat::RefTree::write | ( | od_ostream & |  | ) | const

## Friends And Related Symbol Documentation

## ◆ NodeUnitRef

friend class NodeUnitRef
| friend

## ◆ RefTreeMgr

friend class RefTreeMgr
| friend

## ◆ UnitRef

friend class UnitRef
| friend

## Member Data Documentation

## ◆ beingdeleted_

bool Strat::RefTree::beingdeleted_ = false
| protected

## ◆ contents_

ContentSet Strat::RefTree::contents_
| protected

## ◆ liths_

LithologySet Strat::RefTree::liths_
| protected

## ◆ name_

BufferString Strat::RefTree::name_

## ◆ objectToBeDeleted

Notifier<RefTree> Strat::RefTree::objectToBeDeleted

## ◆ src_

Repos::Source Strat::RefTree::src_

## ◆ udfleaf_

LeafUnitRef& Strat::RefTree::udfleaf_
| protected

## ◆ unitAdded

Notifier<UnitRef> Strat::RefTree::unitAdded

## ◆ unitChanged

Notifier<UnitRef> Strat::RefTree::unitChanged

## ◆ unitToBeDeleted

Notifier<UnitRef> Strat::RefTree::unitToBeDeleted

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025